;---------------------------------------------------------------------------
; Override common states (use same number to override) :
;---------------------------------------------------------------------------

;---------------------------------------------------------------------------
; Initialize (at the start of the round)
[Statedef 5900]
type = S

[State 5900, 1] ;Clear all int variables
type = VarRangeSet
trigger1 = roundsexisted = 0
value = 0
first = 0
last = 57

[State 5900, 2] ;Clear all float variables
type = VarRangeSet
trigger1 = roundsexisted = 0
fvalue = 0

[State 5900, 3] ;Change palette
type = RemapPal
trigger1 = 1
source = 1,1
dest = 1,palno

[State 5900, 4] ;Intro for round 1
type = ChangeState
trigger1 = roundno = 1
value = 190

[State 5900, 4] ;Intro for stage 2
type = ChangeState
trigger1 = roundno != 1
trigger1 = var(59) & floor(exp(1*ln(2)) + 0.5)
trigger1 = !(var(59) & floor(exp(3*ln(2)) + 0.5))
value = 196

[State 5900, 5] ;All other rounds
type = ChangeState
trigger1 = 1
value = 0

;------------------
; Hit by Fast Kung Fu Palm - flying through the air
; (a custom gethit state)
[Statedef 346]
type    = A
movetype= H
physics = N

[State 1026, Velocity]
type = HitVelSet
trigger1 = Time = 0
x = 1
y = 1

[State 1026, Gravity]
type = VelAdd
trigger1 = 1
y = .88

[State 1026, No scroll]
type = ScreenBound
triggerall = Pos y < -15
trigger1 = BackEdgeBodyDist < 65
trigger2 = FrontEdgeBodyDist < 65
value = 1
movecamera = 0,1

[State 1026, Hit wall]
type = ChangeState
triggerall = Pos y < -15
trigger1 = BackEdgeBodyDist <= 20
trigger2 = FrontEdgeBodyDist <= 20
value = 347

[State 1026, Hit ground]
type = SelfState
trigger1 = (Vel y > 0) && (Pos y >= const(movement.air.gethit.groundlevel))
value = 5100

;------------------
; Hit by Fast Kung Fu Palm - bounce off wall
; (a custom gethit state)
[Statedef 348]
type    = A
movetype= H
physics = N

[State 1028, Vel Y]
type = VelSet
trigger1 = Time = 0
y = -12.12

[State 1028, Vel X]
type = VelSet
trigger1 = Time = 0
x = 1.6

[State 1028, Turn]
type = Turn
trigger1 = (Time = 0) && (BackEdgeDist < 30)

[State 1028, Gravity]
type = VelAdd
trigger1 = 1
y = .88

[State 1028, Anim 5050] ;Self falling animation
type = ChangeAnim
trigger1 = Time = 0
trigger1 = !SelfAnimExist(5052)
value = 5050

[State 1028, Anim 5052] ;Self falling animation (diagup type)
type = ChangeAnim
trigger1 = Time = 0
trigger1 = SelfAnimExist(5052)
value = 5052

[State 1028, Anim 5060] ;Coming down - normal
type = ChangeAnim
trigger1 = Vel Y > -2
trigger1 = Anim = 5050
trigger1 = SelfAnimExist(5060)
persistent = 0
value = 5060

[State 1028, Anim 5062] ;Coming down - diagup type
type = ChangeAnim
trigger1 = Vel Y > -2
trigger1 = Anim = 5052
trigger1 = SelfAnimExist(5062)
persistent = 0
value = 5062

[State 1028, Hit ground]
type = SelfState
trigger1 = (Vel y > 0) && (Pos y >= const(movement.down.bounce.groundlevel))
value = 5100

;------------------
; ELECTRIC SHOCK THROUGH YOU
; ELECTRIC SHAQQ THROUGH YOU
[Statedef 440]
type    = A
movetype= H
physics = N
velset = 0,0

[State 0, LifeAdd]
type = LifeAdd
trigger1 = time <= 52
value = -2
kill = ifelse(time>=51,1,0)
absolute = 1
ignorehitpause = 1

[State 0, NotHitBy]
type = NotHitBy
trigger1 = time < 52
value = SCA,NA,SA,HA,NP,SP,HP,NT,ST,HT
time = 2
ignorehitpause = 1

[State 0, NotHitBy]
type = NotHitBy
trigger1 = time >= 52
value = ,NT,ST,HT
time = 2
ignorehitpause = 1

;[State 0, ScreenBound]
;type = ScreenBound
;trigger1 = 1
;value = 1
;movecamera = 1,0
;ignorehitpause = 1

[State 1025, Anim]
type = ChangeAnim2
trigger1 = time = 0
value = 440

[State 0, ChangeAnim]
type = ChangeAnim
trigger1 = time = 0
trigger1 = selfanimexist(7696)
value = 7696

[State 0, PalFXWiz]
type = PalFX
trigger1 = time = 0
trigger1 = anim != 7696
time = 52
add = 100,100,180
mul = 256,256,256
sinadd = -80,-80,-80,10
invertall = 1
color = 0
ignorehitpause = 1

[State 0, Offset]
type = Offset
trigger1 = time < 52
;trigger1 = anim != 7696
x = -4+random%8
y = -4+random%8
ignorehitpause = 1

[State 0, Turn]
type = Turn
trigger1 = time = 52
trigger1 = p2dist x < 0
ignorehitpause = 1

[State 1025, Anim]
type = ChangeAnim2
trigger1 = time = 52
value = 441

[State 0, VelSet]
type = VelSet
trigger1 = time = 52
x = -4.4
y = -8.8

[State 0, VelAdd]
type = VelAdd
trigger1 = time > 52
y = 0.88

[State 0, SelfState]
type = SelfState
trigger1 = time > 52
trigger1 = vel y > 0
trigger1 = pos y + vel y >= const(movement.down.bounce.groundlevel)
value = 5100

;------------------
; BURN
[Statedef 441]
type    = A
movetype= H
physics = N
velset = 0,0

[State 0, LifeAdd]
type = LifeAdd
trigger1 = time = 0
value = -100
kill = 1
absolute = 1
ignorehitpause = 1

[State 0, NotHitBy]
type = NotHitBy
trigger1 = 1
value = SCA,NA,SA,HA,NP,SP,HP,NT,ST,HT
time = 2
ignorehitpause = 1

;[State 0, ScreenBound]
;type = ScreenBound
;trigger1 = 1
;value = 1
;movecamera = 1,0
;ignorehitpause = 1

[State 1025, Anim]
type = ChangeAnim2
trigger1 = time = 0
value = 441

[State 0, ChangeAnim]
type = ChangeAnim
trigger1 = time = 0
trigger1 = selfanimexist(7697)
value = 5012

[State 0, ChangeAnim]
type = ChangeAnim
trigger1 = time = 6
trigger1 = selfanimexist(7697)
value = 7697

[State 0, PalFXWiz]
type = PalFX
trigger1 = (time%10) = 0
trigger1 = anim != 7697
time = 10
add = 40,-70,-200
mul = 256,256,256
sinadd = 40,30,0,10
invertall = 1
color = 0
ignorehitpause = 1

[State 0, HitVelSet]
type = HitVelSet
trigger1 = time = 0
x = 1
y = 1
ignorehitpause = 1

;[State 0, VelSet]
;type = VelSet
;trigger1 = time = 0
;x = -4.4
;y = -4.8

[State 0, VelAdd]
type = VelAdd
trigger1 = time
y = gethitvar(yaccel)

[State 0, SelfState]
type = SelfState
trigger1 = vel y > 0
trigger1 = pos y + vel y >= const(movement.down.bounce.groundlevel)
value = 5100

;----------------------------------------------------------------------
[Statedef 3005]
type = A
movetype = H
physics = N

[State 0, ChangeAnim2]
type = ChangeAnim
trigger1 = time = 0
value = ifelse(selfanimexist(5061),5061,5050)
ignorehitpause = 1
[State 0, ChangeAnim2]
type = ChangeAnim
trigger1 = time = 0
value = anim
elem = animelemno(99)
ignorehitpause = 1

[State 0, HitVelSet]
type = HitVelSet
trigger1 = time = 0
x = 1
y = 1
ignorehitpause = 1
[State 0, HitFallSet]
type = HitFallSet
trigger1 = time = 0
value = 1
[State 0, PosFreeze]
type = PosFreeze
trigger1 = !hitshakeover
value = 1
ignorehitpause = 1

[State 821, 1] ;Gravity
type = VelAdd
Trigger1 = hitshakeover
y = gethitvar(yaccel)

[State 821, 4] ;Hit ground
type = ChangeState
Trigger1 = hitshakeover
trigger1 = Vel Y > 0
trigger1 = Pos Y >= const(movement.down.bounce.groundlevel)
value = 3006 ;Hit ground


;---------------------------------------------------------------------------
; HIT_BOUNCE (bounce into air)
[Statedef 3007]
type    = A
movetype= H
physics = N

[State 5101, 1] ;Coming hit ground anim (normal)
type = ChangeAnim
triggerall = time = 0
trigger1 = anim != [5101,5109]
trigger2 = !SelfAnimExist(5160 + (anim % 10))
value = 5160
[State 5101, 2] ;Coming hit ground anim (for hit up)
type = ChangeAnim
triggerall = time = 0
trigger1 = anim = [5101,5109]
trigger1 = SelfAnimExist(5160 + (anim % 10))
value = 5160 + (anim % 10)

[State 5101, 3]
type = VelSet
trigger1 = Time = 0
x = -1
y = -13.73
[State 5101, 5] ;Acceleration
type = VelAdd
trigger1 = 1
y = gethitvar(yaccel)

[State 5101, 6] ;Hit ground
trigger1 = Vel Y > 0
trigger1 = Pos Y >= const(movement.down.bounce.groundlevel)
type = SelfState
value = 5110


;---------------------------------------------------------------------------
; Custom HUD
; fvar(10) - life p1
; fvar(11) - oldlife p1
; fvar(20) - life p2
; fvar(21) - old life p2
; fvar(22) - old fade
; fvar(24) - power p2
; var(10) - p1 random x
; var(11) - p1 random y
; var(12) - p2 random x
; var(13) - p3 random y
[Statedef 800]
type    = S
movetype= I
physics = N
anim = 9741
velset = 0,0
ctrl = 0

[State init]
type = VarSet
trigger1 = time = 0
fvar(10) = 1
[State init]
type = VarSet
trigger1 = time = 0
fvar(20) = 1

[State reset shake]
type = Null
trigger1 = 1
trigger1 = (var(10):=0) + (var(11):=0) + (var(12):=0) + (var(13):=0)

[State p1 shake]
type = VarSet
trigger1 = parent,var(22)>0
var(10) = -4+random%8
[State p1 shake]
type = VarSet
trigger1 = parent,var(22)>0
var(11) = random%4
[State 0, VarSet]
type = VarSet
trigger1 = 1
fvar(1) = ifelse(numenemy,(enemy,life),1)
[State 0, VarSet]
type = VarSet
trigger1 = 1
fvar(2) = ifelse(numenemy,(enemy,lifemax),1)
[State p1 shake]
type = VarSet
triggerall = numenemy
triggerall = enemy,stateno != [120,169]
trigger1 = !enemy,hitshakeover
trigger2 = enemy,gethitvar(damage)
trigger3 = fvar(20) > (fvar(1)/fvar(2))
var(12) = -4+random%8
[State p1 shake]
type = VarSet
triggerall = numenemy
triggerall = enemy,stateno != [120,169]
trigger1 = !enemy,hitshakeover
trigger2 = enemy,gethitvar(damage)
trigger3 = fvar(20) > (fvar(1)/fvar(2))
var(13) = -4+random%8


[State 0, AssertSpecial]
type = AssertSpecial
trigger1 = 1
flag = nobardisplay
flag2 = timerfreeze
ignorehitpause = 1

[State init moveoffset]
type = VarSet
trigger1 = time = 0
var(0) = 34
[State slide up]
type = VarAdd
trigger1 = roundstate = [2,3]
trigger1 = var(0) > 0
var(0) = -1
[State slide down]
type = VarAdd
trigger1 = roundstate = 4
trigger1 = var(0) < 34
var(0) = 1

;var(59) & floor(exp(1*ln(2)) + 0.5)

[State Create p1 LifebarBG]
type = Explod
trigger1 = time = 0
anim = ifelse((parent,var(59) & floor(exp(1*ln(2)) + 0.5)),1801,801)
ID = 501
pos = 0,floor(gameheight)+var(0)+var(11)
postype = left
facing = 1
vfacing = 1
bindtime = -1
removetime = -1
pausemovetime = 65535
supermovetime = 65535
scale = .66666666,.66666666
sprpriority = 110
ontop = 1
ownpal = 1
ignorehitpause = 1
[State Move p1 LifebarBG]
type = ModifyExplod
trigger1 = numexplod(501)
;anim = ifelse((parent,var(59) & floor(exp(1*ln(2)) + 0.5)),1801,801)
ID = 501
pos = 0,floor(gameheight)+var(0)+var(11)
postype = left
facing = 1
vfacing = 1
bindtime = -1
removetime = -1
pausemovetime = 65535
supermovetime = 65535
scale = .66666666,.66666666
sprpriority = 110
ontop = 1
ownpal = 1
ignorehitpause = 1

[State 0, VarSet]
type = VarSet
trigger1 = 1
fvar(1) = parent,life
[State 0, VarSet]
type = VarSet
trigger1 = 1
fvar(2) = parent,lifemax
[State 0, VarSet]
type = VarAdd
trigger1 = fvar(11) > (fvar(1)/fvar(2))
trigger1 = parent,var(22) <= 0
fvar(11) = -0.001
[State 0, VarSet]
type = VarSet
trigger1 = fvar(11) < (fvar(1)/fvar(2))
fvar(11) = fvar(1)/fvar(2)

[State Create p1 oLife]
type = Explod
trigger1 = time = 0
anim = 803
ID = 503
pos = 0+floor(81*.66666666),floor(gameheight)-floor(14*.66666666)+var(0)+var(11)
postype = left
facing = 1
vfacing = 1
bindtime = -1
removetime = -1
pausemovetime = 65535
supermovetime = 65535
scale = fvar(11)*.66666666,.66666666
sprpriority = 111
ontop = 1
ownpal = 1
ignorehitpause = 1
[State Move p1 oLife]
type = ModifyExplod
trigger1 = numexplod(503)
anim = 803
ID = 503
pos = 0+floor(81*.66666666),floor(gameheight)-floor(14*.66666666)+var(0)+var(11)
postype = left
facing = 1
vfacing = 1
bindtime = -1
removetime = -1
pausemovetime = 65535
supermovetime = 65535
scale = fvar(11)*.66666666,.66666666
sprpriority = 111
ontop = 1
ownpal = 1
ignorehitpause = 1

[State 0, VarSet]
type = VarSet
trigger1 = 1
fvar(1) = parent,life
[State 0, VarSet]
type = VarSet
trigger1 = 1
fvar(2) = parent,lifemax
[State 0, VarSet]
type = VarAdd
trigger1 = fvar(10) > (fvar(1)/fvar(2))
fvar(10) = -0.005
[State 0, VarSet]
type = VarSet
trigger1 = fvar(10) < (fvar(1)/fvar(2))
fvar(10) = fvar(1)/fvar(2)

[State Create p1 Life]
type = Explod
trigger1 = time = 0
anim = 802
ID = 502
pos = 0+floor(81*.66666666),floor(gameheight)-floor(14*.66666666)+var(0)+var(11)
postype = left
facing = 1
vfacing = 1
bindtime = -1
removetime = -1
pausemovetime = 65535
supermovetime = 65535
scale = fvar(10)*.66666666,.66666666
sprpriority = 111
ontop = 1
ownpal = 1
ignorehitpause = 1
[State Move p1 Life]
type = ModifyExplod
trigger1 = numexplod(502)
anim = 802
ID = 502
pos = 0+floor(81*.66666666),floor(gameheight)-floor(14*.66666666)+var(0)+var(11)
postype = left
facing = 1
vfacing = 1
bindtime = -1
removetime = -1
pausemovetime = 65535
supermovetime = 65535
scale = fvar(10)*.66666666,.66666666
sprpriority = 111
ontop = 1
ownpal = 1
ignorehitpause = 1

[State 0, PalFX]
type = PalFX
trigger1 = parent,time = 1
trigger1 = parent,stateno = [200,499]
time = 60
add = 0,0,0
mul = 256,256,256
sinadd = 256,64,64,8
invertall = 0
color = 256
ignorehitpause = 1

[State 0, PalFX]
type = PalFX
triggerall = (parent,time%6) = 0
trigger1 = parent,stateno = [3000,3999]
trigger2 = parent,stateno = 172
time = 12
add = 0,0,0
mul = 256,128,128
sinadd = 128,0,8,6
invertall = 0
color = 0
ignorehitpause = 1

[State Create p1 AttackGem]
type = Explod
trigger1 = time = 0
anim = ifelse((parent,var(59) & floor(exp(1*ln(2)) + 0.5)),1804,804)
ID = 504
pos = 0,floor(gameheight)+var(0)+var(11)
postype = left
facing = 1
vfacing = 1
bindtime = -1
removetime = -1
pausemovetime = 65535
supermovetime = 65535
scale = .66666666,.66666666
sprpriority = 111
ontop = 1
ownpal = 0
ignorehitpause = 1
[State Move p1 AttackGem]
type = ModifyExplod
trigger1 = numexplod(504)
;anim = 804
ID = 504
pos = 0,floor(gameheight)+var(0)+var(11)
postype = left
facing = 1
vfacing = 1
bindtime = -1
removetime = -1
pausemovetime = 65535
supermovetime = 65535
scale = .66666666,.66666666
sprpriority = 111
ontop = 1
ownpal = 0
ignorehitpause = 1


[State Create p2 LifebarBG]
type = Explod
trigger1 = time = 0
anim = ifelse((parent,var(59) & floor(exp(2*ln(2)) + 0.5)),519,510)
ID = 510
pos = floor(348*.66666666)+(var(0)*2)+var(12),floor(20*.66666666)-(var(0)*2)+var(13)
postype = left
facing = 1
vfacing = 1
bindtime = -1
removetime = -1
pausemovetime = 65535
supermovetime = 65535
scale = .66666666,.66666666
sprpriority = 110
ontop = 1
ownpal = 1
ignorehitpause = 1
[State Move p2 LifebarBG]
type = ModifyExplod
trigger1 = numexplod(501)
;anim = 510
ID = 510
pos = floor(348*.66666666)+(var(0)*2)+var(12),floor(20*.66666666)-(var(0)*2)+var(13)
postype = left
facing = 1
vfacing = 1
bindtime = -1
removetime = -1
pausemovetime = 65535
supermovetime = 65535
scale = .66666666,.66666666
sprpriority = 110
ontop = 1
ownpal = 1
ignorehitpause = 1

[State 0, VarSet]
type = VarSet
trigger1 = 1
fvar(1) = ifelse(numenemy,(enemy,life),1)
[State 0, VarSet]
type = VarSet
trigger1 = 1
fvar(2) = ifelse(numenemy,(enemy,lifemax),1)
[State 0, VarSet]
type = VarAdd
trigger1 = fvar(21) > (fvar(1)/fvar(2))
trigger1 = p2movetype != H
fvar(21) = -0.005
[State 0, VarSet]
type = VarSet
trigger1 = fvar(21) < (fvar(1)/fvar(2))
fvar(21) = fvar(1)/fvar(2)

[State Create p2 oldLife]
type = Explod
trigger1 = time = 0
anim = 512
ID = 512
pos = floor(348*.66666666)+(var(0)*2)+var(12),floor(20*.66666666)-(var(0)*2)+var(13)
postype = left
facing = 1
vfacing = 1
bindtime = -1
removetime = -1
pausemovetime = 65535
supermovetime = 65535
scale = fvar(21)*.66666666,.66666666
sprpriority = 111
ontop = 1
ownpal = 1
ignorehitpause = 1
[State Move p2 oldLife]
type = ModifyExplod
trigger1 = numexplod(512)
anim = 512
ID = 512
pos = floor(348*.66666666)+(var(0)*2)+var(12),floor(20*.66666666)-(var(0)*2)+var(13)
postype = left
facing = 1
vfacing = 1
bindtime = -1
removetime = -1
pausemovetime = 65535
supermovetime = 65535
scale = fvar(21)*.66666666,.66666666
sprpriority = 111
ontop = 1
ownpal = 1
ignorehitpause = 1

[State 0, VarSet]
type = VarSet
trigger1 = 1
fvar(1) = ifelse(numenemy,(enemy,life),1)
[State 0, VarSet]
type = VarSet
trigger1 = 1
fvar(2) = ifelse(numenemy,(enemy,lifemax),1)
[State 0, VarSet]
type = VarAdd
trigger1 = fvar(20) > (fvar(1)/fvar(2))
fvar(20) = -0.01
[State 0, VarSet]
type = VarSet
trigger1 = fvar(20) < (fvar(1)/fvar(2))
fvar(20) = fvar(1)/fvar(2)

[State Create p2 Life]
type = Explod
trigger1 = time = 0
anim = 511
ID = 511
pos = floor(348*.66666666)+(var(0)*2)+var(12),floor(20*.66666666)-(var(0)*2)+var(13)
postype = left
facing = 1
vfacing = 1
bindtime = -1
removetime = -1
pausemovetime = 65535
supermovetime = 65535
scale = fvar(20)*.66666666,.66666666
sprpriority = 112
ontop = 1
ownpal = 1
ignorehitpause = 1
[State Move p2 Life]
type = ModifyExplod
trigger1 = numexplod(511)
anim = 511
ID = 511
pos = floor(348*.66666666)+(var(0)*2)+var(12),floor(20*.66666666)-(var(0)*2)+var(13)
postype = left
facing = 1
vfacing = 1
bindtime = -1
removetime = -1
pausemovetime = 65535
supermovetime = 65535
scale = fvar(20)*.66666666,.66666666
sprpriority = 112
ontop = 1
ownpal = 1
ignorehitpause = 1

[State 0, VarSet]
type = VarSet
trigger1 = 1
fvar(1) = ifelse(numenemy,(enemy,power),0)
[State 0, VarSet]
type = VarSet
trigger1 = 1
fvar(2) = ifelse(numenemy,(enemy,powermax),1)
[State 0, VarSet]
type = VarAdd
trigger1 = fvar(24) < (fvar(1)/fvar(2))
fvar(24) = 0.01
[State 0, VarSet]
type = VarSet
trigger1 = fvar(24) >= (fvar(1)/fvar(2))
fvar(24) = fvar(1)/fvar(2)

[State Create p2 power]
type = Explod
trigger1 = time = 0
anim = 514
ID = 514
pos = floor(364*.66666666)+(var(0)*2)+var(12),floor(35*.66666666)-(var(0)*2)+var(13)
postype = left
facing = 1
vfacing = 1
bindtime = -1
removetime = -1
pausemovetime = 65535
supermovetime = 65535
scale = fvar(24)*.66666666,.66666666
sprpriority = 112
ontop = 1
ownpal = 1
ignorehitpause = 1
[State Move p2 power]
type = ModifyExplod
trigger1 = numexplod(511)
anim = 514
ID = 514
pos = floor(364*.66666666)+(var(0)*2)+var(12),floor(35*.66666666)-(var(0)*2)+var(13)
postype = left
facing = 1
vfacing = 1
bindtime = -1
removetime = -1
pausemovetime = 65535
supermovetime = 65535
scale = fvar(24)*.66666666,.66666666
sprpriority = 112
ontop = 1
ownpal = 1
ignorehitpause = 1

[State 0, VarSet]
type = VarSet
trigger1 = 1
fvar(1) = ifelse(numenemy,(enemy,power),0)
[State 0, VarSet]
type = VarSet
trigger1 = 1
fvar(0) = floor(fvar(1)/1000)
[State 0, VarSet]
type = VarSet
trigger1 = fvar(0) > 9
fvar(0) = 9
[State 0, RemoveExplod]
type = RemoveExplod
trigger1 = numexplod(520)
trigger1 = floor(fvar(0))!=0
id = 520
ignorehitpause = 1
[State 0, RemoveExplod]
type = RemoveExplod
trigger1 = numexplod(521)
trigger1 = floor(fvar(0))!=1
id = 521
ignorehitpause = 1
[State 0, RemoveExplod]
type = RemoveExplod
trigger1 = numexplod(522)
trigger1 = floor(fvar(0))!=2
id = 522
ignorehitpause = 1
[State 0, RemoveExplod]
type = RemoveExplod
trigger1 = numexplod(523)
trigger1 = floor(fvar(0))!=3
id = 523
ignorehitpause = 1
[State 0, RemoveExplod]
type = RemoveExplod
trigger1 = numexplod(524)
trigger1 = floor(fvar(0))!=4
id = 524
ignorehitpause = 1
[State 0, RemoveExplod]
type = RemoveExplod
trigger1 = numexplod(525)
trigger1 = floor(fvar(0))!=5
id = 525
ignorehitpause = 1
[State 0, RemoveExplod]
type = RemoveExplod
trigger1 = numexplod(526)
trigger1 = floor(fvar(0))!=6
id = 526
ignorehitpause = 1
[State 0, RemoveExplod]
type = RemoveExplod
trigger1 = numexplod(527)
trigger1 = floor(fvar(0))!=7
id = 527
ignorehitpause = 1
[State 0, RemoveExplod]
type = RemoveExplod
trigger1 = numexplod(528)
trigger1 = floor(fvar(0))!=8
id = 528
ignorehitpause = 1
[State 0, RemoveExplod]
type = RemoveExplod
trigger1 = numexplod(529)
trigger1 = floor(fvar(0))!=9
id = 529
ignorehitpause = 1
[State Create power level]
type = Explod
trigger1 = !numexplod(520+floor(fvar(0)))
anim = 520+floor(fvar(0))
ID = 520+floor(fvar(0))
pos = floor(348*.66666666)+(var(0)*2)+var(12),floor(20*.66666666)-(var(0)*2)+var(13)
postype = left
facing = 1
vfacing = 1
bindtime = -1
removetime = -1
pausemovetime = 65535
supermovetime = 65535
scale = .66666666,.66666666
sprpriority = 110
ontop = 1
ownpal = 1
ignorehitpause = 1
[State Modify power level]
type = ModifyExplod
trigger1 = numexplod(520+floor(fvar(0)))
anim = 520+floor(fvar(0))
ID = 520+floor(fvar(0))
pos = floor(348*.66666666)+(var(0)*2)+var(12),floor(20*.66666666)-(var(0)*2)+var(13)
postype = left
facing = 1
vfacing = 1
bindtime = -1
removetime = -1
pausemovetime = 65535
supermovetime = 65535
scale = .66666666,.66666666
sprpriority = 110
ontop = 1
ownpal = 1
ignorehitpause = 1

[State 0, VarSet]
type = VarSet
trigger1 = 1
fvar(0) = time

[State Create p2 warning]
type = Explod
trigger1 = !numexplod(513)
trigger1 = fvar(20) <= 0.5
trigger1 = fvar(20) > 0
anim = 513
ID = 513
pos = floor(348*.66666666)+(var(0)*2)+var(12),floor(20*.66666666)-(var(0)*2)+var(13)
postype = left
facing = 1
vfacing = 1
bindtime = -1
removetime = -1
pausemovetime = 65535
supermovetime = 65535
scale = .66666666,.66666666
sprpriority = 112
ontop = 1
ownpal = 1
ignorehitpause = 1
trans = addalpha
alpha = floor(abs( sin(fvar(0)* ifelse(fvar(20)<=0.25,.35,.15)  )*255 )) ,256
[State Create p2 warning]
type = ModifyExplod
trigger1 = numexplod(513)
anim = 513
ID = 513
pos = floor(348*.66666666)+(var(0)*2)+var(12),floor(20*.66666666)-(var(0)*2)+var(13)
postype = left
facing = 1
vfacing = 1
bindtime = -1
removetime = -1
pausemovetime = 65535
supermovetime = 65535
scale = .66666666,.66666666
sprpriority = 112
ontop = 1
ownpal = 1
ignorehitpause = 1
trans = addalpha
alpha = floor(abs( sin(fvar(0)* ifelse(fvar(20)<=0.25,.35,.15)  )*255 )) ,256


[State 0, RemoveExplod]
type = RemoveExplod
triggerall = numexplod(513)
trigger1 = fvar(20) > 0.5
trigger2 = fvar(20) <= 0
id = 513

;---------------------------------------------------------------------------
; States that are always executed (use statedef -2)
;---------------------------------------------------------------------------

[Statedef -2]

[State 0, Helper]
type = Helper
trigger1 = winko
trigger1 = roundstate >= 3
;trigger1 = p2statetype = L
trigger1 = !numhelper(1860)
trigger1 = stateno != 171
trigger1 = stateno != 5150
trigger1 = numenemy
trigger1 = enemynear,hitshakeover
trigger1 = !(teammode = simul)
;trigger1 = p2stateno = [5000,5199]
helpertype = normal
name = "GOTCHA"
ID = 1860
stateno = 1865
pos = 0,0
postype = p2
facing = 1
ownpal = 1
supermovetime = 65535
pausemovetime = 65535
ignorehitpause = 1

[State 0, Helper]
type = Helper
trigger1 = lose
trigger1 = roundstate >= 4
trigger1 = !numhelper(4000)
trigger1 = fvar(31) >= 1
helpertype = normal
name = "Results"
ID = 4000
stateno = 4000
pos = 0,0
postype = p1
facing = 1
ownpal = 1
supermovetime = 65535
pausemovetime = 65535
ignorehitpause = 1

[State count time up]
type = VarAdd
triggerall = roundstate = 2
triggerall = stateno != [170,179]
trigger1 = ctrl
trigger2 = fvar(22)
fvar(22) = 1
ignorehitpause = 1

[State 0, AssertSpecial]
type = AssertSpecial
trigger1 = numhelper(3200)
trigger2 = anim = 5 || anim = 6
flag = noautoturn
ignorehitpause = 1

[State No Custom Hud for mirror match]
type = VarSet
triggerall = fvar(32)>0
trigger1 = p2name= "Canine Carrier"
trigger2 = p4name= "Canine Carrier"
fvar(32) = 0
ignorehitpause = 1

;[State DEBUG]
;type = VarSet
;trigger1 = time
;var(59) = var(59) | floor(exp(1*ln(2)) + 0.5)
;ignorehitpause = 1

[State lost a round?]
type = VarSet
;triggerall = !var(59) & floor(exp(1*ln(2)) + 0.5)
triggerall = roundstate >= 4
trigger1 = lose
var(59) = var(59) | floor(exp(1*ln(2)) + 0.5)
ignorehitpause = 1

[State won a round?]
type = VarSet
;triggerall = !var(59) & floor(exp(2*ln(2)) + 0.5)
triggerall = roundstate >= 4
trigger1 = win
var(59) = var(59) | floor(exp(2*ln(2)) + 0.5)
ignorehitpause = 1

[State smoke]
type = Explod
triggerall = stateno != [170,179]
triggerall = stateno != 5150
triggerall = anim != [5110,5150]
triggerall = alive
triggerall = life <= floor(lifemax/3)*2
trigger1 = (gametime%ifelse(life <= floor(lifemax/3),4,8))=0
anim = 920
pos = -40+random%80,0-random%64
postype = p1
facing = ifelse(random<500,-1,1)
vfacing = 1
bindtime = 1
vel = 0,-1-random%3
removetime = -2
scale = 1,1
sprpriority = -6+random%12
ownpal = 1
ignorehitpause = 1

[State 0, RemoveExplod]
type = RemoveExplod
trigger1 = numexplod(202)
trigger1 = anim != 200
id = 202
ignorehitpause = 1

[State 0, RemoveExplod]
type = RemoveExplod
trigger1 = numexplod(249)
trigger1 = anim != 240
id = 249
ignorehitpause = 1

[State 0, RemoveExplod]
type = RemoveExplod
trigger1 = numexplod(342)
trigger1 = anim != 243
id = 342
ignorehitpause = 1

[State 0, RemoveExplod]
type = RemoveExplod
trigger1 = numexplod(442)
trigger1 = anim != 243
id = 442
ignorehitpause = 1

[State 0, RemoveExplod]
type = RemoveExplod
triggerall = numexplod(3060)
trigger1 = anim != 3050
trigger2 = stateno != 3050
id = 3060
ignorehitpause = 1

[State 0, RemoveExplod]
type = RemoveExplod
triggerall = numexplod(3102)
trigger1 = anim != 3100
trigger2 = stateno != 3100
id = 3102
ignorehitpause = 1

[State 0, RemoveExplod]
type = RemoveExplod
triggerall = numexplod(3257)
trigger1 = anim != 3251
trigger2 = stateno != 3251
id = 3257
ignorehitpause = 1
[State 0, RemoveExplod]
type = RemoveExplod
triggerall = numexplod(3258)
trigger1 = anim != 3251
trigger2 = stateno != 3251
id = 3258
ignorehitpause = 1
[State 0, RemoveExplod]
type = RemoveExplod
triggerall = numexplod(3259)
trigger1 = anim != 3251
trigger2 = stateno != 3251
id = 3259
ignorehitpause = 1

[State 0, VarSet]
type = VarSet
trigger1 = stateno != [190,199]
fvar(19) = ifelse(pos y<=-72,-72,pos y)
ignorehitpause = 1
[State 0, VarSet]
type = VarSet
trigger1 = stateno = [190,199]
fvar(19) = ifelse(fvar(0)<=-72,-72,fvar(0))
ignorehitpause = 1
[State 0, ModifyExplod]
type = ModifyExplod
trigger1 = numexplod(3106)
ID = 3106
pos = 0,ceil(-9*(1-fvar(19)/-72))
postype = p1
bindtime = -1
scale = 1,fvar(19)/-72
[State 0, ModifyExplod]
type = ModifyExplod
trigger1 = numexplod(3107)
ID = 3107
pos = 0,ceil(-9*(1-fvar(19)/-72))
postype = p1
bindtime = -1
scale = 1,fvar(19)/-72
[State 0, ModifyExplod]
type = ModifyExplod
trigger1 = numexplod(3108)
ID = 3108
pos = 0,ceil(-9*(1-fvar(19)/-72))
postype = p1
bindtime = -1
scale = 1,fvar(19)/-72
[State 0, ModifyExplod]
type = ModifyExplod
trigger1 = numexplod(3109)
ID = 3109
pos = 0,ceil(-9*(1-fvar(19)/-72))
postype = p1
bindtime = -1
scale = 1,fvar(19)/-72

[State 0, RemoveExplod]
type = RemoveExplod
triggerall = numexplod(3106)
trigger1 = statetype != A
trigger2 = stateno = 172
trigger3 = stateno = 5150
id = 3106
ignorehitpause = 1
[State 0, RemoveExplod]
type = RemoveExplod
triggerall = numexplod(3107)
trigger1 = statetype != A
trigger2 = stateno = 172
trigger3 = stateno = 5150
id = 3107
ignorehitpause = 1
[State 0, RemoveExplod]
type = RemoveExplod
triggerall = numexplod(3108)
trigger1 = statetype != A
trigger2 = stateno = 172
trigger3 = stateno = 5150
id = 3108
ignorehitpause = 1
[State 0, RemoveExplod]
type = RemoveExplod
triggerall = numexplod(3109)
trigger1 = statetype != A
trigger2 = stateno = 172
trigger3 = stateno = 5150
id = 3109
ignorehitpause = 1

[State 0, NotHitBy]
type = NotHitBy
trigger1 = 1
value = SCA,NA,SA,HA,NP,SP,HP,NT,ST,HT
time = 2
ignorehitpause = 1

[State 0, Helper]
type = Helper
trigger1 = alive
trigger1 = !numhelper(500)
helpertype = normal
name = "Super Armor"
ID = 500
stateno = 500
pos = 0,0
postype = p1
facing = 1
ownpal = 1
supermovetime = 65535
pausemovetime = 65535
ignorehitpause = 1
[State 0, Helper]
type = Helper
;trigger1 = alive
trigger1 = !numhelper(810)
;trigger1 = ctrl
;trigger1 = roundstate = 2
helpertype = normal
name = "Control Panel"
ID = 810
stateno = 810
pos = 0,0
postype = p1
facing = 1
ownpal = 1
supermovetime = 65535
pausemovetime = 65535
ignorehitpause = 1
[State 0, Helper]
type = Helper
trigger1 = fvar(32) > 0
trigger1 = !numhelper(800)
helpertype = normal
name = "Custom HUD"
ID = 800
stateno = 800
pos = 0,0
postype = p1
facing = 1
ownpal = 1
supermovetime = 65535
pausemovetime = 65535
ignorehitpause = 1

[State 0, PalFX]
type = PalFX
trigger1 = var(20)
trigger1 = stateno != [3000,3999]
time = 2
add = 128,128,128
mul = 444,444,444
invertall = 0
color = 200
ignorehitpause = 1
[State 0, PalFX]
type = PalFX
trigger1 = var(20)
trigger1 = stateno = [3000,3999]
time = 2
add = 160,0,0
mul = 444,128,128
invertall = 0
color = 128
ignorehitpause = 1

[State 0, LifeAdd]
type = LifeAdd
trigger1 = var(20)
value = 0-var(20)
kill = ifelse(var(59) & floor(exp(1*ln(2)) + 0.5),0,1)
absolute = 0
ignorehitpause = 1

[State DIE]
type = ChangeState
triggerall = roundstate = [2,3]
triggerall = stateno != 171
triggerall = stateno != 172
triggerall = stateno != 5150
trigger1 = !alive
trigger2 = var(59) & floor(exp(1*ln(2)) + 0.5)
trigger2 = life = 1
trigger2 = var(20)
value = ifelse(var(59) & floor(exp(1*ln(2)) + 0.5),172,171)
ctrl = 0

[State 0, VarSet]
type = VarSet
trigger1 = var(20)
var(20) = 0
ignorehitpause = 1

[State 0, VarSet]
type = VarSet
trigger1 = 1
var(22) = 0
ignorehitpause = 1
[State 0, VarSet]
type = VarSet
trigger1 = numhelper(500)
var(22) = helper(500),gethitvar(hitshaketime)
ignorehitpause = 1

[State 0, ChangeAnim]
type = ChangeAnim
triggerall = stateno != [3000,3999]
triggerall = stateno != [171,179]
triggerall = anim != 243
trigger1 = alive
trigger1 = var(22) > 0
trigger1 = animtime != 0
value = anim
elem = animelemno(-1)
ignorehitpause = 1
[State 0, PosFreeze]
type = PosFreeze
triggerall = stateno != [3000,3999]
triggerall = stateno != [171,179]
triggerall = anim != 243
trigger1 = alive
trigger1 = var(22) > 0
trigger1 = animtime != 0
value = 1
ignorehitpause = 1

; if you're making a 10ov.st and copied the statedef -2 in it's entirety, uncomment this strcl so e.g. the hitpauses in both mugen versions would be the same
[State ME AM USING 1.0]
type = VarSet
trigger1 = var(49) != 1
var(49) = 1
ignorehitpause = 1

[State -2, Movehitoner]
type = VarSet
trigger1 = numenemy
var(21) = ifelse(movehit=1&&(enemynear,movereversed!=[1,2]),var(21)+1,0)
ignorehitpause = 1
[State -2, Movehitoner]
type = VarSet
trigger1 = !numenemy
var(19) = ifelse(movehit=1,var(19)+1,0)
ignorehitpause = 1


[State 0, No blocking]
type = AssertSpecial
trigger1 = 1
flag = noairguard
flag2 = nostandguard
flag3 = nocrouchguard
ignorehitpause = 1

[State 0, Helper]
type = Helper
trigger1 = roundstate < 2
trigger1 = !numhelper(444)
helpertype = normal
name = "CONFIG"
ID = 444
stateno = 444
pos = 444,444
postype = p1
facing = 1
ownpal = 1
supermovetime = 65535
pausemovetime = 65535
ignorehitpause = 1

;
; Within StateDef -2, none of your own AI-related code should be placed
; above these next two controllers.

[State -2, StopAI]
type = VarSet
triggerall = var(58) > 0 && !IsHelper
trigger1 = RoundState != 2
trigger2 = !Alive
var(58) = -2
IgnoreHitPause = 1

; This controller is optional.  It allows you treat the AI flag as a boolean
; value rather than an integer value, letting you trigger your AI directives
; with "var(0)" instead of "var(58)>0", and letting you make moves usable only
; by humans by using "!var(0)" instead of "var(58)<1", thus slightly improving
; the size and efficiency of your code.
; Another benefit is that it makes it much easier for users to disable your AI,
; if they so choose.
[State -2, Simplifier]
type = VarSet
;triggerall = !IsHelper
;trigger1 = var(58) = 1
;trigger2 = var(55):=0
trigger1 = !ishelper
var(55) = ifelse((roundstate<=2),ailevel,0)
IgnoreHitPause = 1

[State 0, VarSet]
type = VarSet
trigger1 = var(55)
var(50) = ifelse(ctrl&&var(55),var(50)+1,0)

[State 0, VarSet]
type = VarSet
triggerall = var(55)
trigger1 = prevstateno != [3000,3999]
trigger1 = time = 1
trigger1 = stateno = 52
trigger2 = stateno = [200,999]
trigger2 = time = 6
var(51) = stateno

; thanks to this if you go CTRL+D and see the current distance so once you start AI making you can blast off a notepad and take notes in which distances would various moves hit
[State -2, DTC]
type = DisplayToClipboard
trigger1 = 1
text = "AI = %d, var(59) = %d, x = %f, y = %f"
params = var(58), var(59), (p2bodydist x), (p2dist y)
IgnoreHitPause = 1


